#ifndef BYROWPHRASESOLVER_HPP
#define BYROWPHRASESOLVER_HPP

#include "Common.hpp"
#include "PhraseSolver.hpp"

class ByRowPhraseSolver : public PhraseSolver
{
public:
    class PhraseChar
    {
    public:
        PhraseChar() : m_iPhrase(0), m_iChar(0) {}
        PhraseChar(uint32_t iPhrase, uint32_t iChar)
            : m_iPhrase(iPhrase), m_iChar(iChar) {}

    public:
        uint32_t m_iPhrase;
        uint32_t m_iChar;
    };

    class TableRec
    {
    public:
        TableRec() : m_score(0) {}

    public:
        uint64_t m_score;
        std::vector<char> m_chars;
    };

public:
    ByRowPhraseSolver();
    virtual ~ByRowPhraseSolver() override;

    virtual void processFrame(const PhraseInterface& pi) override;
    virtual void getChars(std::vector<char>* pChars) override;
    virtual bool wantTransformCache() override { return true; }

private:
    bool m_init;
    std::vector<PhraseChar> m_phraseChars;
    std::vector<std::vector<TableRec>> m_table;
    std::vector<std::vector<TableRec>> m_newTable;
    std::vector<std::vector<TableRec>> m_searchTable;
    std::vector<TableRec> m_initTable;
};

#endif
