// -*- mode:c++; c-style:k&r; c-basic-offset:4; indent-tabs-mode: nil; -*-
// vi:set et cin sw=4 cino=>se0n0f0{0}0^0\:0=sl1g0hspst0+sc3C0/0(0u0U0w0m0:

#ifndef FRAME_HPP
#define FRAME_HPP

#include "Common.hpp"

typedef std::tuple<int,int,int> Pos; // x,y,rot; pls do not make unsigned

inline int &pos_x(Pos &p) { return std::get<0>(p); }
inline const int &pos_x(const Pos &p) { return std::get<0>(p); }
inline int &pos_y(Pos &p) { return std::get<1>(p); }
inline const int &pos_y(const Pos &p) { return std::get<1>(p); }
inline int &pos_r(Pos &p) { return std::get<2>(p); }
inline const int &pos_r(const Pos &p) { return std::get<2>(p); }

struct Frame {
    const Pos spawn;
    const std::vector<const Pos> final_locs;
    const std::vector<const Pos> invalid_locs;
    int rot_limit;
    std::vector<int> x_mins;
    std::vector<int> y_mins;
};

#endif // FRAME_HPP

