#ifndef MOVES_HPP
#define MOVES_HPP

#include "Common.hpp"
#include "UnitState.hpp"
#include "Command.hpp"
#include "StateTable.hpp"

class Game;

// Helper classes (implementation details)

class UnitRec
{
public:
    UnitRec() : m_prevState(Cell(), (uint32_t)-1), m_command(Command::E) {}

public:
    UnitState m_prevState;
    Command m_command;
};

// Public interface

class MoveFinder
{
public:
    MoveFinder();

    void findMoves(const Game& game, std::vector<UnitState>* pMoves);
    void getCommands(UnitState move, std::vector<Command>* pCommands) const;

private:
    StateTable<UnitRec> m_units;
    StateTable<UnitRec> m_moves;
};


#endif
