#ifndef TRANSFORM_HPP
#define TRANSFORM_HPP

#include "Common.hpp"
#include "Command.hpp"
#include "Cell.hpp"
#include "Unit.hpp"

inline Cell transformCell(Cell oldPivot, Cell newPivot, uint32_t rot, Cell cell)
{
    oldPivot.m_x -= (oldPivot.m_y >> 1);
    newPivot.m_x -= (newPivot.m_y >> 1);
    cell.m_x -= (cell.m_y >> 1);

    cell.m_x -= oldPivot.m_x;
    cell.m_y -= oldPivot.m_y;

    int32_t a = cell.m_x;
    int32_t b = -cell.m_x - cell.m_y;
    int32_t c = cell.m_y;

    int32_t aNew;
    //int32_t bNew;
    int32_t cNew;

    switch (rot)
    {
    case 1:
        aNew = -b;
        //bNew = -c;
        cNew = -a;
        break;
    case 2:
        aNew = c;
        //bNew = a;
        cNew = b;
        break;
    case 3:
        aNew = -a;
        //bNew = -b;
        cNew = -c;
        break;
    case 4:
        aNew = b;
        //bNew = c;
        cNew = a;
        break;
    case 5:
        aNew = -c;
        //bNew = -a;
        cNew = -b;
        break;
    case 0:
    default:
        aNew = a;
        //bNew = b;
        cNew = c;
    }

    cell.m_x = aNew;
    cell.m_y = cNew;

    cell.m_x += newPivot.m_x;
    cell.m_y += newPivot.m_y;

    cell.m_x += (cell.m_y >> 1);

    return cell;
}

#endif
