#ifndef UNITSTATE_HPP
#define UNITSTATE_HPP

#include "Common.hpp"
#include "Cell.hpp"

class UnitState
{
public:
    UnitState() : m_pos(), m_rot(0) {}
    UnitState(Cell pos, uint32_t rot) : m_pos(pos), m_rot(rot) {}
    UnitState(int32_t x, int32_t y, uint32_t rot) : m_pos(x, y), m_rot(rot) {}

    bool operator==(const UnitState& other) const
    {
        return m_pos == other.m_pos && m_rot == other.m_rot;
    }
    bool operator!=(const UnitState& other) const
    {
        return m_pos != other.m_pos || m_rot != other.m_rot;
    }

    bool operator<(const UnitState& other) const
    {
        if (m_pos.m_x != other.m_pos.m_x)
        {
            return m_pos.m_x < other.m_pos.m_x;
        }
        if (m_pos.m_y != other.m_pos.m_y)
        {
            return m_pos.m_y < other.m_pos.m_y;
        }
        return m_rot < other.m_rot;
    }

public:
    Cell m_pos;
    uint32_t m_rot;
};

#endif
