// -*- mode:c++; c-style:k&r; c-basic-offset:4; indent-tabs-mode: nil; -*-
// vi:set et cin sw=4 cino=>se0n0f0{0}0^0\:0=sl1g0hspst0+sc3C0/0(0u0U0w0m0:

#ifndef VOCABULARY_HPP
#define VOCABULARY_HPP

#include "Common.hpp"
#include "Frame.hpp"

typedef Pos Delta; // x y rot

class Word {
public:
    Word(Delta d, int s) : rpath(1, d), score(s) { }
    Word(const std::vector<const Delta> &ds, int s) : rpath(ds), score(s) { }
    std::vector<const Delta> rpath; // note that this is the reversed path
    int score;
};

class Vocabulary {
public:
    Vocabulary();
    Vocabulary(const std::vector<std::tuple<const std::string,int> > &power_words);
    int size() const { return m_words.size(); };
    const std::vector<const Word> &primitives() const { return m_primitives; };
    const std::vector<const Word> &words() const { return m_words; };
    const std::vector<const std::string> &texts() const { return m_texts; };
private:
    std::vector<const Word> m_primitives;
    std::vector<const Word> m_words;
    std::vector<const std::string> m_texts;
    std::vector<int> m_decode_tbl;
};

#endif // VOCABULARY_HPP

