// -*- mode:c++; c-style:k&r; c-basic-offset:4; indent-tabs-mode: nil; -*-
// vi:set et cin sw=4 cino=>se0n0f0{0}0^0\:0=sl1g0hspst0+sc3C0/0(0u0U0w0m0:

#include <iostream>
#include "Encoder.hpp"

int main(int argc, char **argv) {
    std::cout << "Encoder test" << std::endl;
    std::vector<std::tuple<const std::string, int> > power_words;
    power_words.push_back(std::make_tuple("lddaa", 20));
    Vocabulary vocab(power_words);
    Frame f0 = { std::make_tuple(0,0,0), std::vector<const Pos>(1, std::make_tuple(1, 1, 2)), std::vector<const Pos>() };
    Frame f1 = { std::make_tuple(1,0,2), std::vector<const Pos>(1, std::make_tuple(0, 1, 2)), std::vector<const Pos>() };
    std::vector<const Frame> frames;
    frames.push_back(f0);
    frames.push_back(f1);
    Encoder enc(2, 2, vocab, frames);
    auto soln = enc.run();
    std::cout << "Score: " << std::get<0>(soln) << std::endl;
    std::cout << "Moves: " << std::get<1>(soln) << std::endl;
    return 0;
}

